/*
 * strerror - map error number to descriptive string
 *
 * This version is obviously somewhat Unix-specific.
 */

#define SIZEOF(ary)		(sizeof(ary) / sizeof((ary)[0]))

typedef struct {
	int		err;
	char	*msg;
} DosErr;

DosErr dos[] = {
	103,	"NO FREE STORE",
	105,	"TASK TABLE FULL",
	114,	"BAD TEMPLATE",
	115,	"BAD NUMBER",
	116,	"REQUIRED ARG MISSING",
	117,	"KEY NEEDS ARG",
	118,	"TOO MANY ARGS",
	119,	"UNMATCHED QUOTES",
	120,	"LINE TOO LONG",
	121,	"FILE NOT OBJECT",
	122,	"INVALID RESIDENT LIBRARY",
	201,	"NO DEFAULT DIR",
	202,	"OBJECT IN USE",
	203,	"OBJECT EXISTS",
	204,	"DIR NOT FOUND",
	205,	"OBJECT NOT FOUND",
	206,	"BAD STREAM NAME",
	207,	"OBJECT TOO LARGE",
	209,	"ACTION NOT KNOWN",
	210,	"INVALID COMPONENT NAME",
	211,	"INVALID LOCK",
	212,	"OBJECT WRONG TYPE",
	213,	"DISK NOT VALIDATED",
	214,	"DISK WRITE PROTECTED",
	215,	"RENAME ACROSS DEVICES",
	216,	"DIRECTORY NOT EMPTY",
	217,	"TOO MANY LEVELS",
	218,	"DEVICE NOT MOUNTED",
	219,	"SEEK ERROR",
	220,	"COMMENT TOO BIG",
	221,	"DISK FULL",
	222,	"DELETE PROTECTED",
	223,	"WRITE PROTECTED",
	224,	"READ PROTECTED",
	225,	"NOT A DOS DISK",
	226,	"NO DISK",
	232,	"NO MORE ENTRIES",
	233,	"IS SOFT LINK",
	234,	"OBJECT LINKED",
	235,	"BAD HUNK",
	240,	"RECORD NOT LOCKED",
	241,	"LOCK COLLISION",
	242,	"LOCK TIMEOUT",
	243,	"UNLOCK ERROR",
};

char *strerror(int errnum)
{
	extern int sys_nerr;
	extern char *sys_errlist[];
	static char buff[24 + 10 + 1];

	if (errnum > 0 && errnum < sys_nerr)
		return(sys_errlist[errnum]);
	if (errnum >= dos[0].err && errnum <= dos[SIZEOF(dos)-1].err) {
		register DosErr *ptr;

		for (ptr = dos + SIZEOF(dos); ptr-- > dos; )
			if (errnum == ptr->err)
				return( ptr->msg );
		sprintf(buff, "unknown AmigaDOS error: %d", errnum);
		return(buff);
	}
	if (errnum != 0) {
		sprintf(buff, "unknown error: %d", errnum);
		return(buff);
	} else
		return("no details given");
}
